#ifndef StartupLocationHeadingHandle_h
#define StartupLocationHeadingHandle_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <Map/MapAngleDraggable.h>
#include <Map/MapSelectionHandle.h>

#include "StartupLocationSelection.h"

class StartupLocationHeadingHandle: public MapSelectionHandle,
               public MapAngleDraggable {
        
        DECLARE_CLASS(StartupLocationHeadingHandle)
        
public:
	StartupLocationHeadingHandle(StartupLocationSelection* selection);
        virtual ~StartupLocationHeadingHandle();
        
        virtual void StartDrag(Point3D currentPosition);
        
        virtual void Drag(Point3D currentPosition);
        
        virtual wxString EndDrag();
        
        virtual void AngleDrag(float delta);
        
        const StartupLocationSelection* GetSelection() const {
                return wxDynamicCast(MapSelectionHandle::GetSelection(),StartupLocationSelection);
        }
};

#endif

