#include "StartupLocationRadiusHandle.h"

#include <Map/MapEditor.h>
#include <Map/MapProjection.h>

IMPLEMENT_CLASS(StartupLocationRadiusHandle,MapSelectionHandle);

StartupLocationRadiusHandle::StartupLocationRadiusHandle(StartupLocationSelection* selection):
        MapSelectionHandle(selection)
{
}

StartupLocationRadiusHandle::~StartupLocationRadiusHandle()
{
}

void StartupLocationRadiusHandle::StartDrag(Point3D currentPosition) {
        MapEditor* editor=GetSelection()->GetEditor();
        MapProjection* proj=editor->GetProjection();
        Point3D center=GetSelection()->GetContent()->GetPosition();
        Point3D localcenter=proj->ConvertToLocal(center);
        double radius=GetSelection()->GetContent()->GetRadius();
        double dist=localcenter.distance3D(currentPosition);
        
        _delta=(radius/dist-1)*(currentPosition-localcenter);
}

void StartupLocationRadiusHandle::Drag(Point3D currentPosition) {
        Point3D p=currentPosition+_delta;
        
        MapEditor* editor=GetSelection()->GetEditor();
        MapProjection* proj=editor->GetProjection();
        Point3D center=GetSelection()->GetContent()->GetPosition();
        Point3D localcenter=proj->ConvertToLocal(center);
        double radius=localcenter.distance3D(p);
        
        GetSelection()->GetContent()->SetRadius(radius);
}

wxString StartupLocationRadiusHandle::EndDrag() {
        // FIXME: should delete this object now
        return wxT("Changing startup position radius");
}

