#ifndef BeaconMapObject_h
#define BeaconMapObject_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <Airport/PointMapObject.h>

class BeaconMapObject: public PointMapObject {
        
        DECLARE_CLASS(BeaconMapObject)
        TRANSACTIONOBJECT_DEFINE_SMARTREF(BeaconMapObject);
        
public:
        typedef enum {
                Beacon_None,
                Beacon_WhiteGreen_Flash,
                Beacon_WhiteYellow_Flash,
                Beacon_GreenYellowWhite_Flash,
                Beacon_WhiteWhiteGreen_Flash,
                Beacon_White_Strobe
        } BeaconType;
        
        /* Create a new object */
	BeaconMapObject(TransactionManager* transactionManager,
                        Point3D position,
                        BeaconType beaconType,
                        wxString name);
        
        virtual MapSelection* CreateSelection(MapSelectionManager* manager);

        TRANSACTIONOBJECT_DEFINE_STATE_ACCESSOR_WCOMP(BeaconType,BeaconType,_beaconType)
        TRANSACTIONOBJECT_DEFINE_STATE_ACCESSOR_WUCOMP(wxString,Name,_name,
                                        TRANSACTIONOBJECT_STATEVAR(_name).Cmp(v)==0)
protected:
        typedef struct {
                BeaconType _beaconType;
                wxString _name;
        } State;
        
        TRANSACTIONOBJECT_DEFINE_STATE_MEMENTO(BeaconMapObject,PointMapObject,State)
};

#endif

