#ifndef PavementSelection_h
#define PavementSelection_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <Map/MapSelection.h>

#include <Map/MapDeltaDraggable.h>
#include "PavementMapObject.h"

class PavementSelection: public MapSelection, public MapDeltaDraggable {
        
        DECLARE_CLASS(PavementSelection)
        
public:
	PavementSelection(MapSelectionManager* manager, PavementMapObject* content);
        
        virtual ~PavementSelection();
        
        virtual MapSelectionHandle* HitHandle(Point3D p);
        
        virtual wxRect GetDeviceBounds() const;
        
        virtual void StartDrag(Point3D currentPosition) { MapDeltaDraggable::StartDrag(currentPosition); }
        
        virtual void Drag(Point3D currentPosition) { MapDeltaDraggable::Drag(currentPosition); }
        
        virtual void DeltaDrag(Point3D delta);
        
        virtual void Paint(wxDC& dc);

        virtual void ProvidePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void UpdatePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void MarkDifferingPropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass, MapSelection* firstSelection);
        
        virtual void UpdateObjectFromProperty(wxPGProperty* property);
        
        PavementMapObject* GetContent() const { return wxDynamicCast(MapSelection::GetContent(),PavementMapObject); }
protected:
        int GetHitSide(const Point3D localPoint, const Point3D corners[4], double dl);
        void PaintHandles(wxDC& dc);
};

#endif


