#ifndef WindsockMapObject_h
#define WindsockMapObject_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <Airport/PointMapObject.h>

class WindsockMapObject: public PointMapObject {
        
        DECLARE_CLASS(WindsockMapObject)
        TRANSACTIONOBJECT_DEFINE_SMARTREF(WindsockMapObject);
        
public:
        /* Create a new object */
	WindsockMapObject(TransactionManager* transactionManager,
                          Point3D position,
                          bool isLighted,
                          wxString name);

        virtual MapSelection* CreateSelection(MapSelectionManager* manager);

        TRANSACTIONOBJECT_DEFINE_STATE_ACCESSOR_WCOMP(bool,IsLighted,_isLighted)
        TRANSACTIONOBJECT_DEFINE_STATE_ACCESSOR_WUCOMP(wxString,Name,_name,
                                        TRANSACTIONOBJECT_STATEVAR(_name).Cmp(v)==0)
        
        bool IsLighted() const { return GetIsLighted(); }
protected:
        typedef struct {
                bool _isLighted;
                wxString _name;
        } State;
        
        TRANSACTIONOBJECT_DEFINE_STATE_MEMENTO(WindsockMapObject,PointMapObject,State)
};

#endif

