#ifndef XMLProjectWriter_h
#define XMLProjectWriter_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <Airport/Airport.h>

#include <iostream>

class XMLProjectWriter: public wxObject {
        
        DECLARE_CLASS(XMLProjectWriter)
        
public:
        XMLProjectWriter(Airport::SmartRef airport);
        virtual ~XMLProjectWriter();
        
        void writeProject(std::ostream& os);
protected:
        void writeAirportDefinition(std::ostream& outfile);
        void writeFrequencies(std::ostream& outfile);
        void writeRunways(std::ostream& outfile);
        void writeTaxiways(std::ostream& outfile);
        void writeObjects(std::ostream& outfile);
        void writeGroundNetwork(std::ostream& outfile);
        Airport::SmartRef _airport;
};

#endif

