#if HAVE_CONFIG_H
#  include <config.h>
#endif /* HAVE_CONFIG_H */

#include "MapCalibratedBackgroundImageActionsHandler.h"
#include "MapCalibratedBackgroundImage.h"
#include "CalibrationMode.h"

#include <Map/MapEditor.h>
#include <Map/MapSelectionManager.h>
#include <Map/ModeManager.h>

MapCalibratedBackgroundImageActionsHandler MapCalibratedBackgroundImageActionsHandler::_instance;

IMPLEMENT_CLASS(MapCalibratedBackgroundImageActionsHandler,wxMenu);

MapCalibratedBackgroundImageActionsHandler::MapCalibratedBackgroundImageActionsHandler()
{
}

MapCalibratedBackgroundImageActionsHandler::~MapCalibratedBackgroundImageActionsHandler() {
}

void MapCalibratedBackgroundImageActionsHandler::OnFixedScaleNoRotate(wxCommandEvent& evt) {
        wxMenu *menu=wxDynamicCast(evt.GetEventObject(),wxMenu);
        MapEditor* editor=(MapEditor*)menu->GetClientData();
        MapSelectionManager::SmartRef selmgr=&editor->GetSelectionManager();
        ModeManager& modemgr=editor->GetModeManager();
        
        wxASSERT(selmgr->GetSelections().GetCount()==1);
        MapSelection* sel=selmgr->GetSelections().GetFirst()->GetData();
        MapCalibratedBackgroundImage::SmartRef bgimg=wxDynamicCast(sel->GetContent(),MapCalibratedBackgroundImage);
        CalibrationMode* mode=new CalibrationMode(bgimg,false,true);
        modemgr.InsertOnTop(mode);
}

void MapCalibratedBackgroundImageActionsHandler::OnFixedScaleRotate(wxCommandEvent& evt) {
        wxMenu *menu=wxDynamicCast(evt.GetEventObject(),wxMenu);
        MapEditor* editor=(MapEditor*)menu->GetClientData();
        MapSelectionManager::SmartRef selmgr=&editor->GetSelectionManager();
        ModeManager& modemgr=editor->GetModeManager();
        
        wxASSERT(selmgr->GetSelections().GetCount()==1);
        MapSelection* sel=selmgr->GetSelections().GetFirst()->GetData();
        MapCalibratedBackgroundImage::SmartRef bgimg=wxDynamicCast(sel->GetContent(),MapCalibratedBackgroundImage);
        CalibrationMode* mode=new CalibrationMode(bgimg,true,true);
        modemgr.InsertOnTop(mode);
}

void MapCalibratedBackgroundImageActionsHandler::OnUniformScaleNoRotate(wxCommandEvent& evt) {
        wxMenu *menu=wxDynamicCast(evt.GetEventObject(),wxMenu);
        MapEditor* editor=(MapEditor*)menu->GetClientData();
        MapSelectionManager::SmartRef selmgr=&editor->GetSelectionManager();
        ModeManager& modemgr=editor->GetModeManager();
        
        wxASSERT(selmgr->GetSelections().GetCount()==1);
        MapSelection* sel=selmgr->GetSelections().GetFirst()->GetData();
        MapCalibratedBackgroundImage::SmartRef bgimg=wxDynamicCast(sel->GetContent(),MapCalibratedBackgroundImage);
        CalibrationMode* mode=new CalibrationMode(bgimg,false,false);
        modemgr.InsertOnTop(mode);
}

void MapCalibratedBackgroundImageActionsHandler::OnUniformScaleRotate(wxCommandEvent& evt) {
        wxMenu *menu=wxDynamicCast(evt.GetEventObject(),wxMenu);
        MapEditor* editor=(MapEditor*)menu->GetClientData();
        MapSelectionManager::SmartRef selmgr=&editor->GetSelectionManager();
        ModeManager& modemgr=editor->GetModeManager();
        
        wxASSERT(selmgr->GetSelections().GetCount()==1);
        MapSelection* sel=selmgr->GetSelections().GetFirst()->GetData();
        MapCalibratedBackgroundImage::SmartRef bgimg=wxDynamicCast(sel->GetContent(),MapCalibratedBackgroundImage);
        CalibrationMode* mode=new CalibrationMode(bgimg,true,false);
        modemgr.InsertOnTop(mode);
}

