#ifndef ProjectWizardTypePage_h
#define ProjectWizardTypePage_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <wx/wizard.h>

class ProjectWizardNewAirportPage;
class ProjectWizardNewProjectPage;
class ProjectWizardOpenProjectPage;

class ProjectWizardTypePage: public wxWizardPage {

        DECLARE_CLASS(ProjectWizardTypePage)

public:
        enum {
                New_Airport=0,
                New_Project,
                Open_Project
        };
	ProjectWizardTypePage(wxWizard* parent,
                              ProjectWizardNewAirportPage* newAirportPage,
                              ProjectWizardNewProjectPage* newProjectPage,
                              ProjectWizardOpenProjectPage* openProjectPage,
                              const wxBitmap& bitmap = wxNullBitmap,
                              const wxChar *resource = NULL);
        virtual ~ProjectWizardTypePage();
        virtual wxWizardPage* GetNext() const;
        virtual wxWizardPage* GetPrev() const;

        int GetOperation() const { return _radioBox->GetSelection(); }
        void SetOperation(int op) { _radioBox->SetSelection(op); }
protected:
        wxRadioBox* _radioBox;

        ProjectWizardNewAirportPage* _newAirportPage;
        ProjectWizardNewProjectPage* _newProjectPage;
        ProjectWizardOpenProjectPage* _openProjectPage;
};

#endif

