#ifndef MapDatumProjectionDescriptor_h
#define MapDatumProjectionDescriptor_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include "MapProjectionDescriptor.h"

class MapDatumProjectionDescriptor: public MapProjectionDescriptor {
        
        DECLARE_CLASS(MapDatumProjectionDescriptor)
        
public:
        class Datum {
        public:
                Datum(double a, double b, double e_2, double f_inv):
                        a(a),
                        b(b),
                        e_2(e_2),
                        f_inv(f_inv)
                {
                }
                
                double a;		// Semimajor ellipsoid radius (equatorial radius)
                double b;		// Semiminor ellipsoid radius (polar radius)
                double e_2;		// Eccentricity squared,  e^2 = 2*f - f*f = 1 - b*b / a*a
                double f_inv;		// Inverse flattening,  1/f = a / (a - b)
        };
        
	MapDatumProjectionDescriptor(const wxString& name,
                                     const wxString& description,
                                     wxClassInfo* classInfo,
                                     Datum datum);
        
        Datum GetDatum() const { return _datum; }
protected:
        Datum _datum;
};

#endif

