#ifndef MapDeltaDraggable_h
#define MapDeltaDraggable_h

#include "Map/MapDraggable.h"

/**
 * \brief A MapDeltaDraggable is a MapDraggable that is only interested in the
 *        deltas of the drag movement (e.g. for translation).
 */
class MapDeltaDraggable: public MapDraggable {
public:
        virtual ~MapDeltaDraggable() {}
        
        virtual void StartDrag(Point3D currentPosition) {
                _lastDragPosition=currentPosition;
        }
        
        virtual void Drag(Point3D currentPosition) {
                DeltaDrag(currentPosition-_lastDragPosition);
                _lastDragPosition=currentPosition;
        }
        
        virtual void DeltaDrag(Point3D delta)=0;
protected:
        Point3D _lastDragPosition;
};

#endif

