#if HAVE_CONFIG_H
#  include <config.h>
#endif /* HAVE_CONFIG_H */

#include "MapLayer.h"
#include "MapEditor.h"
#include <wx/listimpl.cpp>
WX_DEFINE_LIST(MapLayerEditors);

IMPLEMENT_ABSTRACT_CLASS(MapLayer,TransactionObject);

MapLayer::MapLayer(TransactionManager* tmgr, wxString name):
        TransactionObject(tmgr),
        _name(name) {
}

MapLayer::~MapLayer() {
}

void MapLayer::Damage() {
        MapLayerEditors::Node* node;
        for (node=_editors.GetFirst();node;node=node->GetNext()) {
                MapEditor* editor=node->GetData();
                editor->DamageRect(GetDeviceBounds(editor));
        }
}
        
void MapLayer::RegisterEditor(MapEditor* editor) {
        wxASSERT_MSG(_editors.Find(editor)==NULL,
                     wxT("Double registration of editor"));
        _editors.Append(editor);
}

void MapLayer::UnregisterEditor(MapEditor* editor) {
        MapLayerEditors::Node* node=_editors.Find(editor);
        wxASSERT_MSG(node!=NULL,
                     wxT("Deregistration of non-registered editor"));
        _editors.DeleteNode(node);
}

