#if HAVE_CONFIG_H
#  include <config.h>
#endif /* HAVE_CONFIG_H */

#include "OSGB36Projection.h"

#include <Map/MapProjectionDescriptor.h>

#include "osgb36.h"

IMPLEMENT_DYNAMIC_CLASS(OSGB36Projection,MapProjection)

void OSGB36Projection::RegisterProjections() {
        MapProjectionDescriptor::RegisterDescriptor(new MapProjectionDescriptor(wxT("OSGB63"),
                                                                        wxT("OSGB36"),
                                                                        CLASSINFO(OSGB36Projection)));
}

OSGB36Projection::OSGB36Projection() {
}

OSGB36Projection::~OSGB36Projection() {
}

bool OSGB36Projection::Init(Point3D centre) {
	// This is here simply for compatibility with the base class
	// - some other projections return a meaningfull true or false on init.
	// TODO - possibly return true if in UK, false otherwise?
	return true;
}

Point3D OSGB36Projection::ConvertToLocal(Point3D pt) {
	return(WGS84ToOSGB36(pt));
}

Point3D OSGB36Projection::ConvertFromLocal(Point3D pt) {
	return(OSGB36ToWGS84(pt));
}
